import es
import playerlib
import weaponlib
import popuplib
import langlib
import cfglib
import cmdlib
import cPickle
import gamethread

import os

points = {}

###################################################################
info = es.AddonInfo()                                             #
info.name        = "Deathrun Store"                               #
info.basename    = "drstore"                                      #
info.cfgpath     = "drstore.cfg"                                  #
info.msgpath     = "translations.ini"                             #
info.version     = "1.0"                                          #
info.author      = "AbNeR_CSS"                                    #
info.url         = "www.TecnoHardClan.com"                        #
info.description = "Script of store for deathrun"                 #
es.ServerVar(info.basename, info.version, info.name).makepublic() #
###################################################################

                                                        
config = cfglib.AddonCFG(es.getAddonPath(info.basename) + "/" + info.cfgpath)
config.text("*****************************************")
config.text("*****************************************")
config.text("%s CFGS" %info.name)   
config.text("*****************************************")
config.text("*****************************************")
config.text("")      

drstore_admins = config.cvar("drstore_admins", "STEAM_0:0:23794352,STEAM_0:0:32378599", "Admin List")  
drstore_cmd = config.cvar("drstore_cmd", "!drstore", "Cmd For Open The Menu")
drstore_credits_survivor = config.cvar("drstore_credits_survivor", "3", "Credits gain if the player survive the round")
drstore_credits_kill = config.cvar("drstore_credits_kill", "4", "Credits gain by kill a player")
drstore_start_credits = config.cvar("drstore_start_credits", "10", "Amount of the player will start")

config.write()

tokens = {}
tokens['prefix'] = '[Deathrun Store]' 
ini = cfglib.AddonINI(es.getAddonPath(info.basename) + "/" +info.msgpath)
text = langlib.Strings(ini)   
    
ini.addGroup('loaded')													      
ini.addValueToGroup('loaded', 'en', '#green$prefix#default Loaded.')
ini.addValueToGroup('loaded', 'pt', '#green$prefix#default Carregado.')
																   
ini.addGroup('unloaded')													   
ini.addValueToGroup('unloaded', 'en', '#green$prefix#default Unloaded.')
ini.addValueToGroup('unloaded', 'pt', '#green$prefix#default Desativado.')

ini.addGroup('not_enough')													           
ini.addValueToGroup('not_enough', 'en', '#green$prefix#default You dont have enough credits.') 	
ini.addValueToGroup('not_enough', 'pt', '#green$prefix#default Voce nao tem creditos suficientes.') 						            
																    
ini.addGroup('are_dead')													    
ini.addValueToGroup('are_dead', 'en', '#green$prefix#default You Dont can buy this item because you are dead.')
ini.addValueToGroup('are_dead', 'pt', '#green$prefix#default Voce nao pode comprar este item porque voce esta morto.')

ini.addGroup('not_are_dead')													    
ini.addValueToGroup('not_are_dead', 'en', '#green$prefix#default You Dont can buy this item because you are not dead.')
ini.addValueToGroup('not_are_dead', 'pt', '#green$prefix#default Voce nao pode comprar este item porque voce nao esta morto.')

ini.addGroup('purchased_item')													    
ini.addValueToGroup('purchased_item', 'en', '#green$prefix#default Player #lightgreen$name #defaultpurchased the item #green$item.')
ini.addValueToGroup('purchased_item', 'pt', '#green$prefix#default Jogador #lightgreen$name #defaultcomprou o item #green$item.')

ini.addGroup('you_have')													   
ini.addValueToGroup('you_have', 'en', '#green$prefix#default You Have $credits credits.')
ini.addValueToGroup('you_have', 'pt', '#green$prefix#default Voce tem $credits creditos.')

ini.addGroup('survivor')													   
ini.addValueToGroup('survivor', 'en', '#green$prefix#default You earned $creditssurvive credits by #lightgreenSurvive The Round.')
ini.addValueToGroup('survivor', 'pt', '#green$prefix#default Voce Ganhou $creditssurvive creditos por #lightgreenSobreviver.')

ini.addGroup('kill')													   
ini.addValueToGroup('kill', 'en', '#green$prefix#default You earned $creditskill credits by #lightgreenKill.')
ini.addValueToGroup('kill', 'pt', '#green$prefix#default Voce Ganhou $creditskill creditos por #lightgreenMatar.')

ini.addGroup('already_have')													   
ini.addValueToGroup('already_have', 'en', '#green$prefix#default You already have the item #green$item.')
ini.addValueToGroup('already_have', 'pt', '#green$prefix#default Voce ja tem o item #green$item.')

ini.addGroup('noclip_end')													   
ini.addValueToGroup('noclip_end', 'en', '#green$prefix#default Your NoClip is Over.')
ini.addValueToGroup('noclip_end', 'pt', '#green$prefix#default Seu Noclip acabou.')

ini.addGroup('god_end')													   
ini.addValueToGroup('god_end', 'en', '#green$prefix#default Your GodMode is over.')
ini.addValueToGroup('god_end', 'pt', '#green$prefix#default Seu GodMode acabou.')

ini.addGroup('not_enough_money')													           
ini.addValueToGroup('not_enough_money', 'en', '#green$prefix#default You dont have enough Money.') 
ini.addValueToGroup('not_enough_money', 'pt', '#green$prefix#default Voce nao tem dinheiro suficiente.') 

ini.addGroup('credits_send')													           
ini.addValueToGroup('credits_send', 'en', '#green$prefix#default Player #green$name#default give #green$amount credits#default to #lightgreen$rname.')
ini.addValueToGroup('credits_send', 'pt', '#green$prefix#default Jogador #green$name#default deu #green$amount creditos#default para #lightgreen$rname.')

ini.addGroup('credits_give')													           
ini.addValueToGroup('credits_give', 'en', '#green$prefix#default Admin #green$admname#default give #green$amount credits#default to #lightgreen$rname.')
ini.addValueToGroup('credits_give', 'pt', '#green$prefix#default Admin #green$admname#default deu #green$amount creditos#default para #lightgreen$rname.')

ini.addGroup('credits_reset')													           
ini.addValueToGroup('credits_reset', 'en', '#green$prefix#default Admin #green$admname#default reset player #green$rname.')  
ini.addValueToGroup('credits_reset', 'pt', '#green$prefix#default Admin #green$admname#default resetou o jogador #green$rname.') 

ini.addGroup('spectator')													           
ini.addValueToGroup('spectator', 'en', '#green$prefix#default You can not buy until they choose a team.')  
ini.addValueToGroup('spectator', 'pt', '#green$prefix#default Voce nao pode comprar ate escolher um time.') 

ini.addGroup('basemenu_youhave')													           
ini.addValueToGroup('basemenu_youhave', 'en', 'You have $credits credits')  
ini.addValueToGroup('basemenu_youhave', 'pt', 'Voce tem $credits creditos')

ini.addGroup('basemenu_back')													           
ini.addValueToGroup('basemenu_back', 'en', '8. Back')  
ini.addValueToGroup('basemenu_back', 'pt', '8. Voltar')

ini.addGroup('basemenu_next')													           
ini.addValueToGroup('basemenu_next', 'en', '9. Next')  
ini.addValueToGroup('basemenu_next', 'pt', '9. Proximo')

ini.addGroup('basemenu_exit')													           
ini.addValueToGroup('basemenu_exit', 'en', '0. Exit')  
ini.addValueToGroup('basemenu_exit', 'pt', '0. Sair')


ini.addGroup('basemenu_store1')													           
ini.addValueToGroup('basemenu_store1', 'en', 'Buy Items')  
ini.addValueToGroup('basemenu_store1', 'pt', 'Comprar itens')

ini.addGroup('basemenu_store2')													           
ini.addValueToGroup('basemenu_store2', 'en', 'Buy Credits')  
ini.addValueToGroup('basemenu_store2', 'pt', 'Comprar Creditos')

ini.addGroup('basemenu_store3')													           
ini.addValueToGroup('basemenu_store3', 'en', 'Send Credits')  
ini.addValueToGroup('basemenu_store3', 'pt', 'Enviar Creditos')

ini.addGroup('basemenu_store4')													           
ini.addValueToGroup('basemenu_store4', 'en', 'Admin Menu')  
ini.addValueToGroup('basemenu_store4', 'pt', 'Admin Menu')

ini.addGroup('basemenu_send1')													           
ini.addValueToGroup('basemenu_send1', 'en', 'Send 5 Credits')  
ini.addValueToGroup('basemenu_send1', 'pt', 'Enviar 5 Creditos')

ini.addGroup('basemenu_send2')													           
ini.addValueToGroup('basemenu_send2', 'en', 'Send 10 Credits')  
ini.addValueToGroup('basemenu_send2', 'pt', 'Enviar 10 Creditos')

ini.addGroup('basemenu_send3')													           
ini.addValueToGroup('basemenu_send3', 'en', 'Send 20 Credits')  
ini.addValueToGroup('basemenu_send3', 'pt', 'Enviar 20 Creditos')

ini.addGroup('basemenu_send4')													           
ini.addValueToGroup('basemenu_send4', 'en', 'Send 100 Credits')  
ini.addValueToGroup('basemenu_send4', 'pt', 'Enviar 100 Creditos')

ini.addGroup('basemenu_adm1')													           
ini.addValueToGroup('basemenu_adm1', 'en', 'Give 10 Credits')  
ini.addValueToGroup('basemenu_adm1', 'pt', 'Dar 10 Creditos')

ini.addGroup('basemenu_adm2')													           
ini.addValueToGroup('basemenu_adm2', 'en', 'Give 100 Credits')  
ini.addValueToGroup('basemenu_adm2', 'pt', 'Dar 100 Creditos')

ini.addGroup('basemenu_adm3')													           
ini.addValueToGroup('basemenu_adm3', 'en', 'Give 1000 Credits')  
ini.addValueToGroup('basemenu_adm3', 'pt', 'Dar 1000 Creditos')

ini.addGroup('basemenu_adm4')													           
ini.addValueToGroup('basemenu_adm4', 'en', 'Reset player')  
ini.addValueToGroup('basemenu_adm4', 'pt', 'Resetar Jogador')

ini.addGroup('basemenu_buy1')													           
ini.addValueToGroup('basemenu_buy1', 'en', '10 Credits - $cifrao 5000')  
ini.addValueToGroup('basemenu_buy1', 'pt', '10 Creditos - R$cifrao 5000')

ini.addGroup('basemenu_buy2')													           
ini.addValueToGroup('basemenu_buy2', 'en', '20 Credits - $cifrao 8000')  
ini.addValueToGroup('basemenu_buy2', 'pt', '20 Creditos - R$cifrao 8000')

ini.addGroup('basemenu_buy3')													           
ini.addValueToGroup('basemenu_buy3', 'en', '50 Credits - $cifrao 16000')  
ini.addValueToGroup('basemenu_buy3', 'pt', '50 Creditos - R$cifrao 16000')

ini.addGroup('basemenu_flashbang')													           
ini.addValueToGroup('basemenu_flashbang', 'en', 'FlashBang')  
ini.addValueToGroup('basemenu_flashbang', 'pt', 'FlashBang')

ini.addGroup('basemenu_smoke')													           
ini.addValueToGroup('basemenu_smoke', 'en', 'SmokeGrenade')  
ini.addValueToGroup('basemenu_smoke', 'pt', 'SmokeGrenade')

ini.addGroup('basemenu_100health')													           
ini.addValueToGroup('basemenu_100health', 'en', '+100 Health')  
ini.addValueToGroup('basemenu_100health', 'pt', '+100 Health')

ini.addGroup('basemenu_speed')													           
ini.addValueToGroup('basemenu_speed', 'en', 'Speed')  
ini.addValueToGroup('basemenu_speed', 'pt', 'Speed')

ini.addGroup('basemenu_fullinvis')													           
ini.addValueToGroup('basemenu_fullinvis', 'en', 'Full Invisibility')  
ini.addValueToGroup('basemenu_fullinvis', 'pt', 'Invisibilidade Total')

ini.addGroup('basemenu_respawn')													           
ini.addValueToGroup('basemenu_respawn', 'en', 'Respawn')  
ini.addValueToGroup('basemenu_respawn', 'pt', 'Renascer')

ini.addGroup('basemenu_legfrog')													           
ini.addValueToGroup('basemenu_legfrog', 'en', 'Leg Of Frog')  
ini.addValueToGroup('basemenu_legfrog', 'pt', 'Perna de Sapo')

ini.addGroup('basemenu_3snoclip')													           
ini.addValueToGroup('basemenu_3snoclip', 'en', 'Noclip 3s')  
ini.addValueToGroup('basemenu_3snoclip', 'pt', 'Noclip 3s')

ini.addGroup('basemenu_10sgod')													           
ini.addValueToGroup('basemenu_10sgod', 'en', 'GodMode 10s')  
ini.addValueToGroup('basemenu_10sgod', 'pt', 'GodMode 10s')

ini.addGroup('basemenu_1roundgod')													           
ini.addValueToGroup('basemenu_1roundgod', 'en', 'GodMode 1 Round')  
ini.addValueToGroup('basemenu_1roundgod', 'pt', 'GodMode 1 Rodada')

ini.addGroup('basemenu_400health')													           
ini.addValueToGroup('basemenu_400health', 'en', '+400 Health')  
ini.addValueToGroup('basemenu_400health', 'pt', '+400 de Vida')

ini.addGroup('basemenu_gravity')													           
ini.addValueToGroup('basemenu_gravity', 'en', 'UltiMate Gravity')  
ini.addValueToGroup('basemenu_gravity', 'pt', 'Gravidade Suprema')

ini.addGroup('basemenu_longjump')													           
ini.addValueToGroup('basemenu_longjump', 'en', 'LongJump')  
ini.addValueToGroup('basemenu_longjump', 'pt', 'LongJump')

ini.addGroup('basemenu_skin')													           
ini.addValueToGroup('basemenu_skin', 'en', 'Funny Skin')  
ini.addValueToGroup('basemenu_skin', 'pt', 'Skin Especial')

ini.addGroup('basemenu_headcrab')													           
ini.addValueToGroup('basemenu_headcrab', 'en', 'HeadCrab')  
ini.addValueToGroup('basemenu_headcrab', 'pt', 'HeadCrab')

ini.addGroup('basemenu_crow')													           
ini.addValueToGroup('basemenu_crow', 'en', 'Crow')  
ini.addValueToGroup('basemenu_crow', 'pt', 'Corvo')

ini.addGroup('basemenu_toilet')													           
ini.addValueToGroup('basemenu_toilet', 'en', 'Toilet')  
ini.addValueToGroup('basemenu_toilet', 'pt', 'Privada')

ini.addGroup('basemenu_barrel')													           
ini.addValueToGroup('basemenu_barrel', 'en', 'Barrel')  
ini.addValueToGroup('basemenu_barrel', 'pt', 'Barril')
ini.write()	




def load():
        global points
        config.execute()
        dictPath = os.path.join(es.getAddonPath(info.basename), "data.db")
        es.msg("#multi", text("loaded", tokens))
        if os.path.isfile(dictPath):
            fileStream = open(dictPath, 'r')
            points = cPickle.load(fileStream)
            fileStream.close()	
        es.regsaycmd(drstore_cmd, '%s/store_send' %info.basename)
                                        

def unload():
        save_database()
        es.msg("#multi", text("unloaded", tokens))
        es.unregsaycmd(drstore_cmd)

def save_database():
    dictPath = os.path.join(es.getAddonPath(info.basename), "data.db")
    fileStream = open(dictPath, 'w')
    cPickle.dump(points, fileStream)
    fileStream.close()

def store_send():
    save_database()
    userid = es.getcmduserid()
    time = es.getplayerteam(userid)
    steamid = es.getplayersteamid(userid)
    if time > 1:
       if not points.has_key(steamid):
          setpoints(steamid)
          storemenu(userid, None)
          save_database()
       else:
          storemenu(userid, None) 
          save_database()
    else:
       es.tell(userid, "#multi", text("spectator", tokens))


def storemenu(userid, args):
        steamid = es.getplayersteamid(userid)
        tokens['credits'] = points[steamid]["credits"]
        menu = popuplib.create('STOREMENU')
        menu.addline('******************')
        menu.addline('Deathrun Store')
        menu.addline(text("basemenu_youhave", tokens))
        menu.addline('******************')
        menu.addline('->1. %s' %text("basemenu_store1", tokens))
        menu.addline('->2. %s' %text("basemenu_store2", tokens))
        menu.addline('->3. %s' %text("basemenu_store3", tokens))
        if steamid in str(drstore_admins).split(','):
           menu.addline('->4. %s' %text("basemenu_store4", tokens))
        menu.addline(text("basemenu_exit", tokens))
        menu.unsend(userid)
        menu.send(userid)
        menu.delete()
        menu.menuselect = storemenu_selected


def storemenu_selected(userid, choice, popupid):
              if choice == 1:
                  store_buyitems1(userid, None)
              if choice == 2:
                  store_buycredits(userid, None)
              if choice == 3:
                  store_sendcredits(userid, None)
              if choice == 4:
                 steamid = es.getplayersteamid(userid)
                 if steamid in str(drstore_admins).split(','):
                    storeadm(userid, None)

def store_sendcredits(userid, args):
        steamid = es.getplayersteamid(userid)
        menu = popuplib.create('STOREADM')
        tokens['credits'] = points[steamid]["credits"]
        menu.addline('******************')
        menu.addline('Deathrun Store')
        menu.addline(text("basemenu_youhave", tokens))
        menu.addline('******************')
        menu.addline('->1. %s' %text("basemenu_send1", tokens))
        menu.addline('->2. %s' %text("basemenu_send2", tokens))
        menu.addline('->3. %s' %text("basemenu_send3", tokens))
        menu.addline('->4. %s' %text("basemenu_send4", tokens))
        menu.addline(text("basemenu_back", tokens))
        menu.addline(text("basemenu_exit", tokens))
        menu.unsend(userid)
        menu.send(userid)
        menu.delete()
        menu.menuselect = store_sendcredits_selected

def store_sendcredits_selected(userid, choice, popupid):
              steamid = es.getplayersteamid(userid)
              if choice == 1:
                  custo = 5
                  if points[steamid]["credits"] >= custo:
                     send5credits = popuplib.construct('send5credits', 'players', '#human', send5credits_selected)
                     send5credits.settitle(text("basemenu_send1", tokens))
	             popuplib.send('send5credits', userid)
                  else:
		    es.tell(userid, "#multi", text("not_enough", tokens))

              if choice == 2:
                  custo = 10
                  if points[steamid]["credits"] >= custo:
                     send10credits = popuplib.construct('send10credits', 'players', '#human', send10credits_selected)
                     send10credits.settitle(text("basemenu_send2", tokens))
	             popuplib.send('send10credits', userid)
                  else:
		    es.tell(userid, "#multi", text("not_enough", tokens))

              if choice == 3:
                  custo = 20
                  if points[steamid]["credits"] >= custo:
                     send20credits = popuplib.construct('send20credits', 'players', '#human', send20credits_selected)
                     send20credits.settitle(text("basemenu_send3", tokens))
	             popuplib.send('send20credits', userid)
                  else:
		    es.tell(userid, "#multi", text("not_enough", tokens))
              

              if choice == 4:
                  custo = 100
                  if points[steamid]["credits"] >= custo:
                     send100credits = popuplib.construct('send100credits', 'players', '#human', send100credits_selected)
                     send100credits.settitle(text("basemenu_send4", tokens))
	             popuplib.send('send100credits', userid)
                  else:
		    es.tell(userid, "#multi", text("not_enough", tokens))

              if choice == 8: 
                 storemenu(userid, None)



def send5credits_selected(userid, choice, popupid):
    receiver = int(choice)
    rsteamid = es.getplayersteamid(receiver)
    steamid = es.getplayersteamid(userid)
    custo = 5
    tokens['amount'] = 5
    tokens['name'] = es.getplayername(userid)
    tokens['rname'] = es.getplayername(receiver)
    points[rsteamid]["credits"] += custo
    points[steamid]["credits"] -= custo
    es.msg("#multi", text("credits_send", tokens))

def send10credits_selected(userid, choice, popupid):
    receiver = int(choice)
    rsteamid = es.getplayersteamid(receiver)
    steamid = es.getplayersteamid(userid)
    custo = 10
    tokens['amount'] = 10
    tokens['name'] = es.getplayername(userid)
    tokens['rname'] = es.getplayername(receiver)
    points[rsteamid]["credits"] += custo
    points[steamid]["credits"] -= custo
    es.msg("#multi", text("credits_send", tokens))


def send20credits_selected(userid, choice, popupid):
    receiver = int(choice)
    rsteamid = es.getplayersteamid(receiver)
    steamid = es.getplayersteamid(userid)
    custo = 20
    tokens['amount'] = 20
    tokens['name'] = es.getplayername(userid)
    tokens['rname'] = es.getplayername(receiver)
    points[rsteamid]["credits"] += custo
    points[steamid]["credits"] -= custo
    es.msg("#multi", text("credits_send", tokens))

def send100credits_selected(userid, choice, popupid):
    receiver = int(choice)
    rsteamid = es.getplayersteamid(receiver)
    steamid = es.getplayersteamid(userid)
    custo = 100
    tokens['amount'] = 100
    tokens['name'] = es.getplayername(userid)
    tokens['rname'] = es.getplayername(receiver)
    points[rsteamid]["credits"] += custo
    points[steamid]["credits"] -= custo
    es.msg("#multi", text("credits_send", tokens))


def storeadm(userid, args):
        steamid = es.getplayersteamid(userid)
        menu = popuplib.create('STOREADM')
        tokens['credits'] = points[steamid]["credits"]
        menu.addline('******************')
        menu.addline('Deathrun Store')
        menu.addline(text("basemenu_youhave", tokens))
        menu.addline('******************')
        menu.addline('->1. %s' %text("basemenu_adm1", tokens))
        menu.addline('->2. %s' %text("basemenu_adm2", tokens))
        menu.addline('->3. %s' %text("basemenu_adm3", tokens))
        menu.addline('->4. %s' %text("basemenu_adm4", tokens))
        menu.addline(text("basemenu_back", tokens))
        menu.addline(text("basemenu_exit", tokens))
        menu.unsend(userid)
        menu.send(userid)
        menu.delete()
        menu.menuselect = storeadm_selected


def storeadm_selected(userid, choice, popupid):
              if choice == 1:
                  give10credits = popuplib.construct('give10credits', 'players', '#human', give10credits_selected)
                  give10credits.settitle(text("basemenu_adm1", tokens))
	          popuplib.send('give10credits', userid)

              if choice == 2:
                  give100credits = popuplib.construct('give100credits', 'players', '#human', give100credits_selected)
                  give100credits.settitle(text("basemenu_adm2", tokens))
	          popuplib.send('give100credits', userid)


              if choice == 3:
                  give1000credits = popuplib.construct('give1000credits', 'players', '#human', give1000credits_selected)
                  give1000credits.settitle(text("basemenu_adm3", tokens))
	          popuplib.send('give1000credits', userid)
              
              if choice == 4:
                  reset = popuplib.construct('reset', 'players', '#human', reset_selected)
                  reset.settitle(text("basemenu_adm4", tokens))
	          popuplib.send('reset', userid)

              if choice == 8: 
                 storemenu(userid, None)


def give10credits_selected(userid, choice, popupid):
    receiver = int(choice)
    rsteamid = es.getplayersteamid(receiver)
    tokens['admname'] = es.getplayername(userid)
    tokens['rname'] = es.getplayername(receiver)
    tokens['amount'] = 10
    points[rsteamid]["credits"] += 10
    es.msg("#multi", text("credits_give", tokens))

def give100credits_selected(userid, choice, popupid):
    receiver = int(choice)
    rsteamid = es.getplayersteamid(receiver)
    tokens['amount'] = 100
    tokens['admname'] = es.getplayername(userid)
    tokens['rname'] = es.getplayername(receiver)
    points[rsteamid]["credits"] += 100
    es.msg("#multi", text("credits_give", tokens))

def give1000credits_selected(userid, choice, popupid):
    receiver = int(choice)
    rsteamid = es.getplayersteamid(receiver)
    tokens['amount'] = 1000
    tokens['admname'] = es.getplayername(userid)
    tokens['rname'] = es.getplayername(receiver)
    points[rsteamid]["credits"] += 1000
    es.msg("#multi", text("credits_give", tokens))

def reset_selected(userid, choice, popupid):
    receiver = int(choice)
    rsteamid = es.getplayersteamid(receiver)
    tokens['admname'] = es.getplayername(userid)
    tokens['rname'] = es.getplayername(receiver)
    points[rsteamid]["credits"] = drstore_start_credits
    es.msg("#multi", text("credits_give", tokens))




def store_buycredits(userid, args):
        steamid = es.getplayersteamid(userid)
        tokens['credits'] = points[steamid]["credits"]
        tokens['cifrao'] = '$'
        menu = popuplib.create('STORE_BUYCREDITS')
        menu.addline('******************')
        menu.addline('Deathrun Store')
        menu.addline(text("basemenu_youhave", tokens))
        menu.addline('******************')
        menu.addline('->1. %s' %text("basemenu_buy1", tokens))
        menu.addline('->2. %s' %text("basemenu_buy2", tokens))
        menu.addline('->3. %s' %text("basemenu_buy3", tokens))
        menu.addline(text("basemenu_back", tokens))
        menu.addline(text("basemenu_exit", tokens))
        menu.unsend(userid)
        menu.send(userid)
        menu.delete()
        menu.menuselect = store_buycredits_selected


def store_buycredits_selected(userid, choice, popupid):
              steamid = es.getplayersteamid(userid)
              tokens['name'] = es.getplayername(userid)
              player = playerlib.getPlayer(userid)
              money = es.getplayerprop(userid, 'CCSPlayer.m_iAccount')
              if choice == 1: 
                 tokens['item'] = "10 Credits"
                 custo = 5000
                 tokens['credits'] = points[steamid]["credits"] + 10
                 if money >= custo:
                    points[steamid]["credits"] += 10
                    es.setplayerprop(userid, 'CCSPlayer.m_iAccount', money - custo)
	            store_buycredits(userid, None)
                    es.msg("#multi", text("purchased_item", tokens))
		    es.tell(userid, "#multi", text("you_have", tokens))
                 else:
		    es.tell(userid, "#multi", text("not_enough_money", tokens))

              if choice == 2: 
                 tokens['item'] = "20 Credits"
                 custo = 8000
                 tokens['credits'] = points[steamid]["credits"] + 20
                 if money >= custo:
                    points[steamid]["credits"] += 20
                    es.setplayerprop(userid, 'CCSPlayer.m_iAccount', money - custo)
	            store_buycredits(userid, None)
                    es.msg("#multi", text("purchased_item", tokens))
		    es.tell(userid, "#multi", text("you_have", tokens))
                 else:
		    es.tell(userid, "#multi", text("not_enough_money", tokens))

              if choice == 3: 
                 tokens['item'] = "50 Credits"
                 custo = 16000
                 tokens['credits'] = points[steamid]["credits"] + 50
                 if money >= custo:
                    points[steamid]["credits"] += 50
                    es.setplayerprop(userid, 'CCSPlayer.m_iAccount', money - custo)
	            store_buycredits(userid, None)
                    es.msg("#multi", text("purchased_item", tokens))
		    es.tell(userid, "#multi", text("you_have", tokens))
                 else:
		    es.tell(userid, "#multi", text("not_enough_money", tokens))

              if choice == 8: 
                 storemenu(userid, None)


def store_buyitems1(userid, args):
        steamid = es.getplayersteamid(userid)
        menu = popuplib.create('STORE_BUYITEMS1')
        tokens['credits'] = points[steamid]["credits"]
        menu.addline('******************')
        menu.addline('Deathrun Store')
        menu.addline(text("basemenu_youhave", tokens))
        menu.addline('******************')
        menu.addline('->1. %s - 5cr' %text("basemenu_flashbang", tokens))
        menu.addline('->2. %s - 5cr' %text("basemenu_smoke", tokens))
        menu.addline('->3. %s - 10cr' %text("basemenu_100health", tokens))
        menu.addline('->4. %s - 5cr' %text("basemenu_speed", tokens))
        menu.addline('->5. %s - 25cr' %text("basemenu_fullinvis", tokens))
        menu.addline('->6. %s - 15cr' %text("basemenu_respawn", tokens))
        menu.addline('->7. %s - 15cr' %text("basemenu_legfrog", tokens))
        menu.addline(text("basemenu_back", tokens))
        menu.addline(text("basemenu_next", tokens))
        menu.addline(text("basemenu_exit", tokens))
        menu.unsend(userid)
        menu.send(userid)
        menu.delete()
        menu.menuselect = store_buyitems1_selected

def store_buyitems1_selected(userid, choice, popupid):
              steamid = es.getplayersteamid(userid)
              tokens['name'] = es.getplayername(userid)
              player = playerlib.getPlayer(userid)
              time = es.getplayerteam(userid)
              if choice == 1: 
                 tokens['item'] = text("basemenu_flashbang", tokens)
                 custo = 5
                 tokens['credits'] = points[steamid]["credits"] - custo
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    if points[steamid]["credits"] >= custo:
                       	give(userid,'weapon_flashbang')
			points[steamid]["credits"] -= custo
	                store_buyitems1(userid, None)
                        es.msg("#multi", text("purchased_item", tokens))
		        es.tell(userid, "#multi", text("you_have", tokens))
                    else:
			es.tell(userid, "#multi", text("not_enough", tokens))
                 else: 
                    es.tell(userid, "#multi", text("are_dead", tokens))


              if choice == 2: 
                 tokens['item'] = text("basemenu_smoke", tokens)
                 custo = 5
                 tokens['credits'] = points[steamid]["credits"] - custo
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    if points[steamid]["credits"] >= custo:
                       	give(userid, 'weapon_smokegrenade')
			points[steamid]["credits"] -= custo
	                store_buyitems1(userid, None)
                        es.msg("#multi", text("purchased_item", tokens))
		        es.tell(userid, "#multi", text("you_have", tokens))
                    else:
			es.tell(userid, "#multi", text("not_enough", tokens))
                 else: 
                    es.tell(userid, "#multi", text("are_dead", tokens))


              if choice == 3: 
                 tokens['item'] = text("basemenu_100health", tokens)
                 custo = 10
                 tokens['credits'] = points[steamid]["credits"] - custo
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    if points[steamid]["credits"] >= custo:
                       	health(player, 100)
			points[steamid]["credits"] -= custo
	                store_buyitems1(userid, None)
                        es.msg("#multi", text("purchased_item", tokens))
		        es.tell(userid, "#multi", text("you_have", tokens))
                    else:
			es.tell(userid, "#multi", text("not_enough", tokens))
                 else: 
                    es.tell(userid, "#multi", text("are_dead", tokens))


              if choice == 4: 
                 tokens['item'] = text("basemenu_speed", tokens)
                 custo = 5
                 tokens['credits'] = points[steamid]["credits"] - custo
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    if points[steamid]["credits"] >= custo:
                      if points[steamid]["speed"] == 0:
                       	 speed(player, 2.0)
			 points[steamid]["credits"] -= custo
	                 store_buyitems1(userid, None)
                         es.msg("#multi", text("purchased_item", tokens))
		         es.tell(userid, "#multi", text("you_have", tokens))
                      else:
                         es.tell(userid, "#multi", text("already_have", tokens))
 
                    else:
			es.tell(userid, "#multi", text("not_enough", tokens))
                 else: 
                    es.tell(userid, "#multi", text("are_dead", tokens))


              if choice == 5: 
                 tokens['item'] = text("basemenu_fullinvis", tokens)
                 custo = 25
                 tokens['credits'] = points[steamid]["credits"] - custo
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    if points[steamid]["credits"] >= custo:
                      if points[steamid]["invis"] == 0:
                       	 invis(player)
			 points[steamid]["credits"] -= custo
	                 store_buyitems1(userid, None)
                         es.msg("#multi", text("purchased_item", tokens))
		         es.tell(userid, "#multi", text("you_have", tokens))
                      else:
                         es.tell(userid, "#multi", text("already_have", tokens))

                    else:
			es.tell(userid, "#multi", text("not_enough", tokens))
                 else: 
                    es.tell(userid, "#multi", text("are_dead", tokens))


              if choice == 6: 
                 tokens['item'] = text("basemenu_respawn", tokens)
                 custo = 10
                 tokens['credits'] = points[steamid]["credits"] - custo
                 if es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                  if time > 1:
                    if points[steamid]["credits"] >= custo:
                       	respawn(player)
			points[steamid]["credits"] -= custo
	                store_buyitems1(userid, None)
                        es.msg("#multi", text("purchased_item", tokens))
		        es.tell(userid, "#multi", text("you_have", tokens))
                    else:
			es.tell(userid, "#multi", text("not_enough", tokens))
                  else:
                     es.tell(userid, "#multi", text("spectator", tokens))
                 else: 
                    es.tell(userid, "#multi", text("not_are_dead", tokens))

              if choice == 7: 
                 tokens['item'] = text("basemenu_legfrog", tokens)
                 custo = 15
                 tokens['credits'] = points[steamid]["credits"] - custo
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    if points[steamid]["credits"] >= custo:
                      if points[steamid]["legfrog"] == 0:
                       	 legfrog(player)
			 points[steamid]["credits"] -= custo
	                 store_buyitems1(userid, None)
                         es.msg("#multi", text("purchased_item", tokens))
		         es.tell(userid, "#multi", text("you_have", tokens))
                      else:
                         es.tell(userid, "#multi", text("already_have", tokens))

                    else:
			es.tell(userid, "#multi", text("not_enough", tokens))
                 else: 
                    es.tell(userid, "#multi", text("are_dead", tokens))


              if choice == 8: 
                 storemenu(userid, None)

              if choice == 9: 
                 store_buyitems2(userid, None)



def store_buyitems2(userid, args):
        steamid = es.getplayersteamid(userid)
        menu = popuplib.create('STORE_BUYITEMS1')
        menu.addline('******************')
        menu.addline('Deathrun Store')
        menu.addline(text("basemenu_youhave", tokens))
        menu.addline('******************')
        menu.addline('->1. %s - 50cr' %text("basemenu_3snoclip", tokens))
        menu.addline('->2. %s - 40cr' %text("basemenu_10sgod", tokens))
        menu.addline('->3. %s - 100cr' %text("basemenu_1roundgod", tokens))
        menu.addline('->4. %s - 30cr' %text("basemenu_400health", tokens))
        menu.addline('->5. %s - 20cr' %text("basemenu_gravity", tokens))
        menu.addline('->6. %s - 25cr' %text("basemenu_longjump", tokens))
        menu.addline('->7. %s - 20cr' %text("basemenu_skin", tokens))
        menu.addline(text("basemenu_back", tokens))
        menu.addline(text("basemenu_exit", tokens))
        menu.unsend(userid)
        menu.send(userid)
        menu.delete()
        menu.menuselect = store_buyitems2_selected

def store_buyitems2_selected(userid, choice, popupid):
              steamid = es.getplayersteamid(userid)
              time = es.getplayerteam(userid)
              tokens['name'] = es.getplayername(userid)
              player = playerlib.getPlayer(userid)
              if choice == 1: 
                 tokens['item'] = text("basemenu_3snoclip", tokens)
                 custo = 50
                 tokens['credits'] = points[steamid]["credits"] - custo
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    if points[steamid]["credits"] >= custo:
                      if points[steamid]["noclip"] == 0:
                       	 noclip(player, 3.0)
			 points[steamid]["credits"] -= custo
	                 store_buyitems2(userid, None)
                         es.msg("#multi", text("purchased_item", tokens))
		         es.tell(userid, "#multi", text("you_have", tokens))
                      else:
                         es.tell(userid, "#multi", text("already_have", tokens))
 
                    else:
			es.tell(userid, "#multi", text("not_enough", tokens))
                 else: 
                    es.tell(userid, "#multi", text("are_dead", tokens))


              if choice == 2: 
                 tokens['item'] = text("basemenu_10sgod", tokens)
                 custo = 40
                 tokens['credits'] = points[steamid]["credits"] - custo
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    if points[steamid]["credits"] >= custo:
                      if points[steamid]["god"] == 0:
                       	 god(player, 10.0)
			 points[steamid]["credits"] -= custo
	                 store_buyitems2(userid, None)
                         es.msg("#multi", text("purchased_item", tokens))
		         es.tell(userid, "#multi", text("you_have", tokens))
                      else:
                         es.tell(userid, "#multi", text("already_have", tokens))
 
                    else:
			es.tell(userid, "#multi", text("not_enough", tokens))
                 else: 
                    es.tell(userid, "#multi", text("are_dead", tokens))

              if choice == 3: 
                 tokens['item'] = text("basemenu_1roundgod", tokens)
                 custo = 100
                 tokens['credits'] = points[steamid]["credits"] - custo
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    if points[steamid]["credits"] >= custo:
                      if points[steamid]["god"] == 0:
                       	 god(player, 0)
			 points[steamid]["credits"] -= custo
	                 store_buyitems2(userid, None)
                         es.msg("#multi", text("purchased_item", tokens))
		         es.tell(userid, "#multi", text("you_have", tokens))
                      else:
                         es.tell(userid, "#multi", text("already_have", tokens))
 
                    else:
			es.tell(userid, "#multi", text("not_enough", tokens))
                 else: 
                    es.tell(userid, "#multi", text("are_dead", tokens))

              if choice == 4: 
                 tokens['item'] = text("basemenu_400health", tokens)
                 custo = 30
                 tokens['credits'] = points[steamid]["credits"] - custo
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    if points[steamid]["credits"] >= custo:
                       	health(player, 400)
			points[steamid]["credits"] -= custo
	                store_buyitems2(userid, None)
                        es.msg("#multi", text("purchased_item", tokens))
		        es.tell(userid, "#multi", text("you_have", tokens))
                    else:
			es.tell(userid, "#multi", text("not_enough", tokens))
                 else: 
                    es.tell(userid, "#multi", text("are_dead", tokens))


              if choice == 5: 
                 tokens['item'] = text("basemenu_gravity", tokens)
                 custo = 20
                 tokens['credits'] = points[steamid]["credits"] - custo
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    if points[steamid]["credits"] >= custo:
                      if points[steamid]["gravity"] == 0:
                       	gravity(player, 0.3)
			points[steamid]["credits"] -= custo
	                store_buyitems2(userid, None)
                        es.msg("#multi", text("purchased_item", tokens))
		        es.tell(userid, "#multi", text("you_have", tokens))
                      else:
                         es.tell(userid, "#multi", text("already_have", tokens))
                    else:
			es.tell(userid, "#multi", text("not_enough", tokens))
                 else: 
                    es.tell(userid, "#multi", text("are_dead", tokens))


              if choice == 6: 
                 tokens['item'] = text("basemenu_longjump", tokens)
                 custo = 25
                 tokens['credits'] = points[steamid]["credits"] - custo
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    if points[steamid]["credits"] >= custo:
                      if points[steamid]["longjump"] == 0:
                       	longjump(player)
			points[steamid]["credits"] -= custo
	                store_buyitems2(userid, None)
                        es.msg("#multi", text("purchased_item", tokens))
		        es.tell(userid, "#multi", text("you_have", tokens))
                      else:
                         es.tell(userid, "#multi", text("already_have", tokens))

                    else:
			es.tell(userid, "#multi", text("not_enough", tokens))
                 else: 
                    es.tell(userid, "#multi", text("are_dead", tokens))

              if choice == 7: 
                 tokens['item'] = text("basemenu_skin", tokens)
                 custo = 20
                 tokens['credits'] = points[steamid]["credits"] - custo
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    if points[steamid]["credits"] >= custo:
                        points[steamid]["credits"] -= custo
                       	funnyskin(userid, None)
                        es.msg("#multi", text("purchased_item", tokens))
		        es.tell(userid, "#multi", text("you_have", tokens))
                    else:
			es.tell(userid, "#multi", text("not_enough", tokens))
                 else: 
                    es.tell(userid, "#multi", text("are_dead", tokens))

              if choice == 8:
	         store_buyitems1(userid, None)


def funnyskin(userid, args):
        steamid = es.getplayersteamid(userid)
        menu = popuplib.create('STORE_BUYITEMS1')
        tokens['credits'] = points[steamid]["credits"]
        menu.addline('******************')
        menu.addline('Deathrun Store')
        menu.addline(text("basemenu_youhave", tokens))
        menu.addline('******************')
        menu.addline('->1. %s - 50cr' %text("basemenu_headcrab", tokens))
        menu.addline('->2. %s - 40cr' %text("basemenu_crow", tokens))
        menu.addline('->3. %s - 100cr' %text("basemenu_toilet", tokens))
        menu.addline('->4. %s - 30cr' %text("basemenu_barrel", tokens))
        menu.unsend(userid)
        menu.send(userid)
        menu.delete()
        menu.menuselect = funnyskin_selected


def funnyskin_selected(userid, choice, popupid):
              player = playerlib.getPlayer(userid)
              if choice == 0:
                 funnyskin(userid, None)

              if choice == 1:
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    player.setModel('headcrab')
                 else:
                    es.tell(userid, "#multi", text("are_dead", tokens))

              if choice == 2:
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    player.setModel('crow')
                 else:
                    es.tell(userid, "#multi", text("are_dead", tokens))

              if choice == 3:
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    player.setModel('/props/cs_militia/toilet')
                 else:
                    es.tell(userid, "#multi", text("are_dead", tokens))

              if choice == 4:
                 if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                    player.setModel('props_c17/oildrum001')
                 else:
                    es.tell(userid, "#multi", text("are_dead", tokens))

              if choice > 4:
                 funnyskin(userid, None)




def es_map_start(event_var):
    save_database()

def round_start(event_var):
    save_database()

       


#SKILLS

def give(userid, item):
    es.server.cmd('es_give %s %s' % (userid, item))

def health(player, health):
    player.health += health
    
def speed(player, speed):
    steamid = es.getplayersteamid(player)
    player.setSpeed(speed)
    points[steamid]["speed"] = 1

def invis(player):
    steamid = es.getplayersteamid(player)
    points[steamid]["invis"] = 1
    player.setColor(255,255,255,0)
    player.setWeaponColor(255,255,255,0)

def respawn(player):
    es.server.cmd('es_xsetplayerprop %s CCSPlayer.m_iPlayerState 0' %player)
    es.server.cmd('es_xsetplayerprop %s CCSPlayer.baseclass.m_lifeState 512' %player)
    es.server.cmd('es_xspawnplayer %s' %player)

def noclip(player, time):
    steamid = es.getplayersteamid(player)
    points[steamid]["noclip"] = 1
    player.noclip = 1
    if time != 0:
       gamethread.delayed(time, removenoclip, (steamid, player))

def removenoclip(steamid, player):
    points[steamid]["noclip"] = 0
    player.noclip = 0
    es.tell(player, "#multi", text("noclip_end", tokens))

def god(player, time):
    steamid = es.getplayersteamid(player)
    points[steamid]["god"] = 1
    player.godmode(1)
    if time != 0:
       gamethread.delayed(time, removegod, (steamid, player))

def removegod(steamid, player):
    points[steamid]["god"] = 0
    player.godmode(0)
    es.tell(player, "#multi", text("god_end", tokens))

def gravity(player, gravity):
    return False

def longjump(player):
    steamid = es.getplayersteamid(player)
    points[steamid]["longjump"] = 1

def legfrog(player):
    steamid = es.getplayersteamid(player)
    points[steamid]["legfrog"] = 1

def gravity(player, gravity):
    steamid = es.getplayersteamid(player)
    points[steamid]["gravity"] = 1
    es.server.cmd('mp_disable_autokick %s' %player)
    es.server.cmd('es_xfire %s !self addoutput "gravity %s"' % (player, gravity))
    


#EVENTS
def round_end(ev):
    save_database()
    tokens['creditssurvive'] = drstore_credits_survivor
    survivorlist = es.getUseridList()
    if drstore_credits_survivor > 0:
     for ply in survivorlist:
       psteamid = es.getplayersteamid(ply)
       if not es.getplayerprop(ply, 'CBasePlayer.pl.deadflag') and psteamid != 'BOT': 
          points[psteamid]["credits"] += drstore_credits_survivor
          es.tell(ply, "#multi", text("survivor", tokens)) 

    
def es_player_validated(ev):
    steamid = ev["networkid"]
    if not points.has_key(steamid):
       setpoints(steamid)
    else:
       setnosavepoints(steamid)


def player_spawn(ev):
    save_database()
    steamid = es.getplayersteamid(ev['userid'])
    if not points.has_key(steamid):
       setpoints(steamid)
    else:
       setnosavepoints(steamid)


def player_death(ev):
    asteamid = es.getplayersteamid(ev['attacker'])
    steamid = es.getplayersteamid(ev['userid'])
    if steamid != 'BOT':
      if not points.has_key(steamid):
         setpoints(steamid)
      else:
         setnosavepoints(steamid)
  
    tokens['creditskill'] = drstore_credits_kill
    if asteamid != 'BOT' and ev['es_attackerteam'] != ev['es_userteam'] and drstore_credits_kill > 0:
       points[asteamid]["credits"] += drstore_credits_kill
       es.tell(ev['attacker'], "#multi", text("kill", tokens))


def player_jump(ev):
        steamid = es.getplayersteamid(ev['userid'])
        longjump_increasesize = 6
        if steamid != 'BOT' and points[steamid]["legfrog"] >= 1:
           es.delayed(0.1, "playerset push %s 0 300 1" %ev['userid'])


# LongJump scripted by ERAZOR aka intensityy
        if steamid != 'BOT' and points[steamid]["longjump"] >= 1:
           vec1 = es.getplayerprop(ev['userid'], 'CBasePlayer.localdata.m_vecVelocity[0]')
	   vec2 = es.getplayerprop(ev['userid'], 'CBasePlayer.localdata.m_vecVelocity[1]')
	   vec1 = (longjump_increasesize * vec1) * (1 / 5.1)
	   vec2 = (longjump_increasesize * vec2) * (1 / 5.1)
	   vector = "%s,%s,0" % (vec1, vec2)
	   es.setplayerprop(ev['userid'], 'CBasePlayer.localdata.m_vecBaseVelocity', vector)



#FIRST JOIN TO SERVER
def setpoints(steamid):
    points[steamid] = {}
    points[steamid]["credits"] = drstore_start_credits
    points[steamid]["longjump"] = 0
    points[steamid]["speed"] = 0
    points[steamid]["invis"] = 0   
    points[steamid]["noclip"] = 0
    points[steamid]["god"] = 0
    points[steamid]["gravity"] = 0
    points[steamid]["legfrog"] = 0

#Already saved Steamid
def setnosavepoints(steamid):
    player = es.getcmduserid(steamid)
    es.server.cmd('es_xfire %s !self addoutput "gravity %s"' % (player, 1.0))
    points[steamid]["longjump"] = 0
    points[steamid]["speed"] = 0
    points[steamid]["invis"] = 0
    points[steamid]["noclip"] = 0
    points[steamid]["god"] = 0
    points[steamid]["gravity"] = 0
    points[steamid]["legfrog"] = 0


		 